; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib

    include \masm32\macros\macros.asm
    include timers.asm
StrLen2 PROTO :DWORD ; Agner Fog's high speed string length algo
; 
    .data
      str1 db "my other brother darryl",0
    .code
; 
start: 
; 
    ;repeat 3          ; Used to check sensitivity to alignment
    ;  nop
    ;endm
    
    counter_begin 10000000, REALTIME_PRIORITY_CLASS
      invoke StrLen2, ADDR str1
    counter_end
    print ustr$(eax)
    print chr$(" cycles",13,10)

    counter_begin 10000000, HIGH_PRIORITY_CLASS
      invoke StrLen2, ADDR str1
    counter_end
    print ustr$(eax)
    print chr$(" cycles",13,10)

    timer_begin 10000000, REALTIME_PRIORITY_CLASS
      invoke StrLen2, ADDR str1
    timer_end
    print ustr$(eax)
    print chr$(" ms",13,10)

    timer_begin 10000000, HIGH_PRIORITY_CLASS
      invoke StrLen2, ADDR str1
    timer_end
    print ustr$(eax)
    print chr$(" ms",13,10)

    mov   eax, input(13,10,"Press enter to exit...")
    exit

align 4
db 15 dup (0)
; 

StrLen2 proc item:DWORD

  ; -------------------------------------------------------------
  ; This procedure has been adapted from an algorithm written by
  ; Agner Fog. It has the unusual characteristic of reading up to
  ; three bytes past the end of the buffer as it uses DWORD size
  ; reads. It is measurably faster than a classic byte scanner on
  ; large linear reads and has its place where linear read speeds
  ; are important.
  ; -------------------------------------------------------------

    push    ebx
    mov     eax,item               ; get pointer to string
    lea     edx,[eax+3]            ; pointer+3 used in the end
  @@:     
    mov     ebx,[eax]              ; read first 4 bytes
    add     eax,4                  ; increment pointer
    lea     ecx,[ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                    ; invert all bytes
    and     ecx,ebx                ; and these two
    and     ecx,80808080h    
    jz      @B                     ; no zero bytes, continue loop
    test    ecx,00008080h          ; test first two bytes
    jnz     @F
    shr     ecx,16                 ; not in the first 2 bytes
    add     eax,2
  @@:
    shl     cl,1                   ; use carry flag to avoid branch
    sbb     eax,edx                ; compute length
    pop     ebx

    ret

StrLen2 endp

end start
